﻿local options = { 
    type='group',
    args = {
         LowWarn = {
            type = 'text',
            name = 'lowwarning',
            desc = 'Low Mana Warning Level (%)',
            get = "GetLow",
            set = "SetLow",
            usage = "<New Percentage>",
         },
         CritWarn = {
            type = 'text',
            name = 'critwarning',
            desc = 'Critical Mana Warning Level (%)',
            get = "GetCrit",
            set = "SetCrit",
            usage = "<New Percentage>",
         },
         LowWarnMsg = {
            type = 'text',
            name = 'lowwarningmessage',
            desc = 'Low Mana Warning Message',
            get = "GetLowMsg",
            set = "SetLowMsg",
            usage = "<New Low Mana Warning Message>",
         },
         CritWarnMsg = {
            type = 'text',
            name = 'critwarningmessage',
            desc = 'Critical Mana Warning Message',
            get = "GetCritMsg",
            set = "SetCritMsg",
            usage = "<New Critical Mana Warning Message>",
         },
         Channel = {
            type = 'text',
            name = 'reportchannel',
            desc = 'Where Warnings Are Displayed',
            get = "GetReportChannel",
            set = "SetReportChannel",
            usage = "<SAY | PARTY | RAID_WARNING>",
         },
    },
}

ManaWatcher = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
ManaWatcher:RegisterChatCommand("/manawatcher", "/mw", options)

-- Set Defaults
ManaWatcher:RegisterDB("ManaWatcherDB", "ManaWatcherDBPC")
ManaWatcher:RegisterDefaults("profile", {
	maxmana = UnitManaMax("player"),
	lowwarning = 35,
	critwarning = 15,
	lowwarningmessage = "-=Healers Mana is Low=-",
	critwarningmessage = "-=Healers Mana CRITICAL, Only healing main tank!=-",
	reportchannel = "RAID_WARNING",
} )

x = 1
y = "hello"
recentRW = 0


function ManaWatcher:OnInitialize()
    -- Called when the addon is loaded
    self:Print("|cffffffffManaWatcher 1.1 Loaded|r")
end

function ManaWatcher:OnEnable()
	-- Called when the addon is enabled
	self:RegisterEvent("UNIT_MANA")
	self:RegisterEvent("UNIT_MAXMANA")
	lowwarningreset = self.db.profile.lowwarning + 20
	critwarningreset = self.db.profile.critwarning + 20
end

function ManaWatcher:UNIT_MANA()
	curmana = UnitMana("player") / self.db.profile.maxmana * 100
	--self:Print(recentRW)
	if(floor(curmana) <= self.db.profile.lowwarning and recentRW == 0) then
		--self:Print(self.db.profile.lowwarningmessage)
		SendChatMessage(self.db.profile.lowwarningmessage, self.db.profile.reportchannel, nil, nil);
		recentRW = 1
	elseif(floor(curmana) <= self.db.profile.critwarning and recentRW == 1) then
		--self:Print(self.db.profile.critwarningmessage)
		SendChatMessage(self.db.profile.critwarningmessage, self.db.profile.reportchannel, nil, nil);
		recentRW = 2
	elseif(floor(curmana) >= lowwarningreset and recentRW == 1) then
		recentRW = 0
	elseif(floor(curmana) >= critwarningreset and recentRW == 2) then
		recentRW = 1
	end
end

function ManaWatcher:UNIT_MAXMANA()
	self.db.profile.maxmana = UnitManaMax("player")
end


function ManaWatcher:OnDisable()
    -- Called when the addon is disabled
end


--Config Functions
function ManaWatcher:GetLow()
    return self.db.profile.lowwarning
end

function ManaWatcher:SetLow(newValue)
    self.db.profile.lowwarning = newValue
end

function ManaWatcher:GetCrit()
    return self.db.profile.critwarning
end

function ManaWatcher:SetCrit(newValue)
    self.db.profile.critwarning = newValue
end

function ManaWatcher:GetLowMsg()
    return self.db.profile.lowwarningmessage
end

function ManaWatcher:SetLowMsg(newValue)
    self.db.profile.lowwarningmessage = newValue
end

function ManaWatcher:GetCritMsg()
    return self.db.profile.critwarningmessage
end

function ManaWatcher:SetCritMsg(newValue)
    self.db.profile.critwarningmessage = newValue
end

function ManaWatcher:GetReportChannel()
    return self.db.profile.reportchannel
end

function ManaWatcher:SetReportChannel(newValue)
    self.db.profile.reportchannel = newValue
end